/*!
 * wbm-modem@1.2.5
 * 
 *   Copyright © 2020 WAGO Kontakttechnik GmbH & Co. KG
 * 
 *   License: 
 *     WAGO Software License Agreement
 * 
 *   Contributors:
 *     
 * 
 *   Description:
 *     Modem configuration
 * 
 *   
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports.modem=t():e.modem=t()}(window,(function(){return function(e){var t={};function o(i){if(t[i])return t[i].exports;var n=t[i]={i:i,l:!1,exports:{}};return e[i].call(n.exports,n,n.exports,o),n.l=!0,n.exports}return o.m=e,o.c=t,o.d=function(e,t,i){o.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:i})},o.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},o.t=function(e,t){if(1&t&&(e=o(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var i=Object.create(null);if(o.r(i),Object.defineProperty(i,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var n in e)o.d(i,n,function(t){return e[t]}.bind(null,n));return i},o.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return o.d(t,"a",t),t},o.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},o.p="",o(o.s=1)}([function(e,t,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var i=function(){function e(e){this.base=e}return e.prototype.onRouteChange=function(e){},e.prototype.unload=function(){},e}();t.ViewController=i},function(e,t,o){"use strict";var i=this&&this.__awaiter||function(e,t,o,i){return new(o||(o=Promise))((function(n,r){function a(e){try{s(i.next(e))}catch(e){r(e)}}function l(e){try{s(i.throw(e))}catch(e){r(e)}}function s(e){var t;e.done?n(e.value):(t=e.value,t instanceof o?t:new o((function(e){e(t)}))).then(a,l)}s((i=i.apply(e,t||[])).next())}))},n=this&&this.__generator||function(e,t){var o,i,n,r,a={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return r={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(r[Symbol.iterator]=function(){return this}),r;function l(r){return function(l){return function(r){if(o)throw new TypeError("Generator is already executing.");for(;a;)try{if(o=1,i&&(n=2&r[0]?i.return:r[0]?i.throw||((n=i.return)&&n.call(i),0):i.next)&&!(n=n.call(i,r[1])).done)return n;switch(i=0,n&&(r=[2&r[0],n.value]),r[0]){case 0:case 1:n=r;break;case 4:return a.label++,{value:r[1],done:!1};case 5:a.label++,i=r[1],r=[0];continue;case 7:r=a.ops.pop(),a.trys.pop();continue;default:if(!(n=(n=a.trys).length>0&&n[n.length-1])&&(6===r[0]||2===r[0])){a=0;continue}if(3===r[0]&&(!n||r[1]>n[0]&&r[1]<n[3])){a.label=r[1];break}if(6===r[0]&&a.label<n[1]){a.label=n[1],n=r;break}if(n&&a.label<n[2]){a.label=n[2],a.ops.push(r);break}n[2]&&a.ops.pop(),a.trys.pop();continue}r=t.call(e,a)}catch(e){r=[6,e],i=0}finally{o=n=0}if(5&r[0])throw r[1];return{value:r[0]?r[1]:void 0,done:!0}}([r,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var r=o(2),a=o(3),l=o(5);base.plugin.register("wbm-modem",(function(e){return i(this,void 0,void 0,(function(){var t,i,s,d,c,u,f;return n(this,(function(n){return t=new a.ProviderList(e),i=new l.MobileNetworkConfig(e,t),s=o(11),d=new r.FirmwareUploadSectionViewController(e),s.sections.push(d),c=e.viewGenerator.generate(e,s),u={title:{default:"Configuration of internal 3G Modem",localized:"modem-page-title"},note:{default:"Changes will take effect immediately",localized:"modem-page-note"},content:[o(12),i,t,o(13),c]},f=e.viewGenerator.generate(e,u),e.parameter.observe("modem.unlocksimbypin",{kind:"called"},(function(){return f.load()})),e.parameter.observe("modem.unlocksimbypuk",{kind:"called"},(function(){return f.load()})),e.parameter.observe("modem.firmware.update",{kind:"called"},(function(){return c.load()})),[2,{id:"modem",title:{fallback:"Modem",key:"modem-menu-entry"},description:{fallback:"Modem configuration",key:"modem-menu-entry-description"},priority:0,controller:f}]}))}))}))},function(e,t,o){"use strict";var i,n=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var o in t)t.hasOwnProperty(o)&&(e[o]=t[o])})(e,t)},function(e,t){function o(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),r=this&&this.__awaiter||function(e,t,o,i){return new(o||(o=Promise))((function(n,r){function a(e){try{s(i.next(e))}catch(e){r(e)}}function l(e){try{s(i.throw(e))}catch(e){r(e)}}function s(e){var t;e.done?n(e.value):(t=e.value,t instanceof o?t:new o((function(e){e(t)}))).then(a,l)}s((i=i.apply(e,t||[])).next())}))},a=this&&this.__generator||function(e,t){var o,i,n,r,a={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return r={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(r[Symbol.iterator]=function(){return this}),r;function l(r){return function(l){return function(r){if(o)throw new TypeError("Generator is already executing.");for(;a;)try{if(o=1,i&&(n=2&r[0]?i.return:r[0]?i.throw||((n=i.return)&&n.call(i),0):i.next)&&!(n=n.call(i,r[1])).done)return n;switch(i=0,n&&(r=[2&r[0],n.value]),r[0]){case 0:case 1:n=r;break;case 4:return a.label++,{value:r[1],done:!1};case 5:a.label++,i=r[1],r=[0];continue;case 7:r=a.ops.pop(),a.trys.pop();continue;default:if(!(n=(n=a.trys).length>0&&n[n.length-1])&&(6===r[0]||2===r[0])){a=0;continue}if(3===r[0]&&(!n||r[1]>n[0]&&r[1]<n[3])){a.label=r[1];break}if(6===r[0]&&a.label<n[1]){a.label=n[1],n=r;break}if(n&&a.label<n[2]){a.label=n[2],a.ops.push(r);break}n[2]&&a.ops.pop(),a.trys.pop();continue}r=t.call(e,a)}catch(e){r=[6,e],i=0}finally{o=n=0}if(5&r[0])throw r[1];return{value:r[0]?r[1]:void 0,done:!0}}([r,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var l=function(e){function t(t){var o=e.call(this,t)||this;return o.view=document.createElement("wbm-certificates-upload-form"),o}return n(t,e),t.prototype.load=function(){return r(this,void 0,void 0,(function(){var e,t,o,i=this;return a(this,(function(n){return this.view.innerHTML='        \n            <div class="section titled-section" >\n                <span class="title" taid="section-title-modem-firmware-upload">New Software</span>\n                <div class="section-body">\n                    <div class="field" taid="field-modem-firmware-upload-label" >\n                        <div class="control">\n                            <label class="file-input" data-placeholder="Choose file..." data-filename=""><input type="file" taid="field-control"></label>\n                        </div>\n                        <button taid="action-modem-firmware-upload" class="action" disabled="disabled">Install</button>\n                    </div>\n                </div>\n            </div>\n        ',(e=this.view.querySelector("button")).addEventListener("click",(function(){return i.uploadButtonPressed()})),t=this.view.querySelector("input"),o=this.view.querySelector("label.file-input"),t.addEventListener("change",(function(){var i=t.files&&t.files.length&&t.files[0].name||"";o.setAttribute("data-filename",i),e.disabled=!i})),[2]}))}))},t.prototype.uploadButtonPressed=function(){return r(this,void 0,void 0,(function(){var e,t,o=this;return a(this,(function(i){switch(i.label){case 0:return(e=this.view.querySelector("div.section")).classList.add("submitting"),t=function(){return r(o,void 0,void 0,(function(){var t,o,i,n,r,l;return a(this,(function(a){switch(a.label){case 0:t=this.view.querySelector("input"),o=t.files[0],i="/tmp/modem_software_upload",a.label=1;case 1:return a.trys.push([1,3,,4]),[4,this.base.transfer.upload([o],i)];case 2:return a.sent(),[3,4];case 3:return n=a.sent(),e.classList.remove("submitting"),this.base.modalPresenter.showErrorDialog(this.base,{title:this.base.localization.localized({key:"modem-firmware-upload-failed-error-modal-title",fallback:"Upload failed"}),message:this.base.localization.localized({key:"modem-firmware-upload-failed-error-modal-message",fallback:"Could not upload the file"}),detailMessage:n.message}),[2];case 4:return a.trys.push([4,6,,7]),[4,this.base.parameter.execute("modem.firmware.update",{filepath:i+"/"+o.name})];case 5:if((r=a.sent()).error)throw r.error;return[3,7];case 6:return l=a.sent(),this.base.transfer.cleanUp(),e.classList.remove("submitting"),this.base.modalPresenter.showErrorDialog(this.base,{title:this.base.localization.localized({key:"modem-firmware-installation-failed-error-modal-title",fallback:"Installation failed"}),message:this.base.localization.localized({key:"modem-firmware-installation-failed-error-modal-message",fallback:"Could not install the uploaded file"}),detailMessage:l.message}),[2];case 7:return t.value="",t.dispatchEvent(new CustomEvent("change")),e.classList.remove("submitting"),[2]}}))}))},[4,this.base.modalPresenter.showLoadingDialog(this.base,{title:this.base.localization.localized({fallback:"Update in progress",key:"modem-update-progress-modal-title"}),message:this.base.localization.localized({fallback:"The device must not be disconnected from the power during the update process. This could damage the modem.",key:"modem-update-progress-modal-message"})},t())];case 1:return i.sent(),[2]}}))}))},t}(o(0).ViewController);t.FirmwareUploadSectionViewController=l},function(e,t,o){"use strict";var i,n=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var o in t)t.hasOwnProperty(o)&&(e[o]=t[o])})(e,t)},function(e,t){function o(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),r=this&&this.__awaiter||function(e,t,o,i){return new(o||(o=Promise))((function(n,r){function a(e){try{s(i.next(e))}catch(e){r(e)}}function l(e){try{s(i.throw(e))}catch(e){r(e)}}function s(e){var t;e.done?n(e.value):(t=e.value,t instanceof o?t:new o((function(e){e(t)}))).then(a,l)}s((i=i.apply(e,t||[])).next())}))},a=this&&this.__generator||function(e,t){var o,i,n,r,a={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return r={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(r[Symbol.iterator]=function(){return this}),r;function l(r){return function(l){return function(r){if(o)throw new TypeError("Generator is already executing.");for(;a;)try{if(o=1,i&&(n=2&r[0]?i.return:r[0]?i.throw||((n=i.return)&&n.call(i),0):i.next)&&!(n=n.call(i,r[1])).done)return n;switch(i=0,n&&(r=[2&r[0],n.value]),r[0]){case 0:case 1:n=r;break;case 4:return a.label++,{value:r[1],done:!1};case 5:a.label++,i=r[1],r=[0];continue;case 7:r=a.ops.pop(),a.trys.pop();continue;default:if(!(n=(n=a.trys).length>0&&n[n.length-1])&&(6===r[0]||2===r[0])){a=0;continue}if(3===r[0]&&(!n||r[1]>n[0]&&r[1]<n[3])){a.label=r[1];break}if(6===r[0]&&a.label<n[1]){a.label=n[1],n=r;break}if(n&&a.label<n[2]){a.label=n[2],a.ops.push(r);break}n[2]&&a.ops.pop(),a.trys.pop();continue}r=t.call(e,a)}catch(e){r=[6,e],i=0}finally{o=n=0}if(5&r[0])throw r[1];return{value:r[0]?r[1]:void 0,done:!0}}([r,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var l=function(e){function t(t){var i=e.call(this,t)||this;return i.didLoad=!1,i.view=document.createElement("wbm-modem-provider-list-form"),i.form=t.viewGenerator.generate(t,o(4)),i.view.appendChild(i.form.view),i}return n(t,e),t.prototype.load=function(){return r(this,void 0,void 0,(function(){return a(this,(function(e){switch(e.label){case 0:return this.didLoad?[3,2]:(this.didLoad=!0,[4,this.form.load()]);case 1:e.sent(),this.addProviderList(this.form.view.querySelector("div.section-body")),this.addRefreshButton(this.form.view.querySelector("div.actions")),e.label=2;case 2:return[2]}}))}))},t.prototype.addRefreshButton=function(e){var t=this,o=document.createElement("button");o.id="modem-provider-list-refresh-button",o.classList.add("action"),o.textContent=this.base.localization.localized({key:"refresh",fallback:"Refresh"}),o.addEventListener("click",(function(){return t.refreshProviderList()})),e.appendChild(o)},t.prototype.addProviderList=function(e){e.innerHTML='<div id="modem-provider-list"></div>'},t.prototype.getProviderList=function(){return this.providerList},t.prototype.onProviderListRefresh=function(e){this.refreshCallback=e},t.prototype.refreshProviderList=function(){return r(this,void 0,void 0,(function(){var e,t,o,i,n,r,l,s,d,c,u;return a(this,(function(a){switch(a.label){case 0:return(e=this.form.view.querySelector("#modem-provider-list")).innerHTML="",t=this.base.parameter.read(["modem.mobilenetwork.providerlist.*.name","modem.mobilenetwork.providerlist.*.type","modem.mobilenetwork.providerlist.*.id","modem.mobilenetwork.providerlist.*.state"]),[4,this.base.modalPresenter.showLoadingDialog(this.base,{title:this.base.localization.localized({key:"loading-modem-provider-list-modal-title",fallback:"Reading provider list..."})},t)];case 1:return a.sent(),[4,t];case 2:if((o=a.sent()).some((function(e){return!!e.error&&(i=e.error.message,!0)})))this.base.modalPresenter.showErrorDialog(this.base,{title:"Failed to read providers",message:"An error occured while reading the provider list",detailMessage:i});else{for(n=o.length/4,this.providerList=[],r=0;r<n;r++)l=o[r].value,s=o[r+n].value,d=o[r+2*n].value,c=o[r+3*n].value,this.providerList.push({name:l,type:s,id:d,state:c}),(u=document.createElement("div")).classList.add("field"),u.innerHTML="<label>"+l+"|"+s+"</label><span>ID: "+d+", "+c+"</span>",e.appendChild(u);this.refreshCallback&&this.refreshCallback()}return[2]}}))}))},t}(o(0).ViewController);t.ProviderList=l},function(e){e.exports=JSON.parse('{"title":{"default":"Provider List","localized":"modem-mobile-network-configuration-form-title"},"sections":[{"fields":[]}]}')},function(e,t,o){"use strict";var i,n=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var o in t)t.hasOwnProperty(o)&&(e[o]=t[o])})(e,t)},function(e,t){function o(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),r=this&&this.__awaiter||function(e,t,o,i){return new(o||(o=Promise))((function(n,r){function a(e){try{s(i.next(e))}catch(e){r(e)}}function l(e){try{s(i.throw(e))}catch(e){r(e)}}function s(e){var t;e.done?n(e.value):(t=e.value,t instanceof o?t:new o((function(e){e(t)}))).then(a,l)}s((i=i.apply(e,t||[])).next())}))},a=this&&this.__generator||function(e,t){var o,i,n,r,a={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return r={next:l(0),throw:l(1),return:l(2)},"function"==typeof Symbol&&(r[Symbol.iterator]=function(){return this}),r;function l(r){return function(l){return function(r){if(o)throw new TypeError("Generator is already executing.");for(;a;)try{if(o=1,i&&(n=2&r[0]?i.return:r[0]?i.throw||((n=i.return)&&n.call(i),0):i.next)&&!(n=n.call(i,r[1])).done)return n;switch(i=0,n&&(r=[2&r[0],n.value]),r[0]){case 0:case 1:n=r;break;case 4:return a.label++,{value:r[1],done:!1};case 5:a.label++,i=r[1],r=[0];continue;case 7:r=a.ops.pop(),a.trys.pop();continue;default:if(!(n=(n=a.trys).length>0&&n[n.length-1])&&(6===r[0]||2===r[0])){a=0;continue}if(3===r[0]&&(!n||r[1]>n[0]&&r[1]<n[3])){a.label=r[1];break}if(6===r[0]&&a.label<n[1]){a.label=n[1],n=r;break}if(n&&a.label<n[2]){a.label=n[2],a.ops.push(r);break}n[2]&&a.ops.pop(),a.trys.pop();continue}r=t.call(e,a)}catch(e){r=[6,e],i=0}finally{o=n=0}if(5&r[0])throw r[1];return{value:r[0]?r[1]:void 0,done:!0}}([r,l])}}};Object.defineProperty(t,"__esModule",{value:!0});var l=o(0);o(6);var s=function(e){function t(t,i){var n=e.call(this,t)||this;n.providerListIsVisible=!1,n.providerList=i,n.view=document.createElement("wbm-modem-mobile-network-config-form");var r=o(10),a=r.sections[0].fields[1];return n.signalField=t.viewGenerator.generate(t,a),r.sections[0].fields[1]=n.signalField,n.signalField.view.classList.add("signal-quality-indicator"),n.form=t.viewGenerator.generate(t,r),n.view.appendChild(n.form.view),n.providerList.onProviderListRefresh((function(){n.providerListIsVisible&&n.showManualProviderSelectionMenu()})),n}return n(t,e),t.prototype.load=function(){return r(this,void 0,void 0,(function(){var e=this;return a(this,(function(t){return[2,this.form.load().then((function(){return r(e,void 0,void 0,(function(){var e,t,o,i,n,r=this;return a(this,(function(a){return(e=this.getModeSelectElement()).addEventListener("change",(function(){"MANUAL"===e.value?r.showManualProviderSelectionMenu():r.hideManualProviderSelectionMenu()})),e.dispatchEvent(new CustomEvent("change")),this.signalField.view.querySelector("i")||(t=this.signalField.view.querySelector(".control"),(o=document.createElement("i")).classList.add("material-icons"),o.innerText="wifi",t.parentElement.insertBefore(o,t)),null!=(i=this.signalField.view.querySelector('[taid="field-modem-mobile-network-configuration-signal-quality-field-title"] input'))&&(n=parseInt(i.value),i.value=i.value+" %",this.signalField.view.classList.remove("low","medium","high"),n>=75?this.signalField.view.classList.add("high"):n>50?this.signalField.view.classList.add("medium"):n>0&&this.signalField.view.classList.add("low")),[2]}))}))}))]}))}))},t.prototype.getModeSelectElement=function(){return this.form.view.querySelector('[taid="field-modem-mobile-network-configuration-selection-mode-field-title"] select')},t.prototype.showManualProviderSelectionMenu=function(){return r(this,void 0,void 0,(function(){var e,t,o,i;return a(this,(function(n){switch(n.label){case 0:return this.providerListIsVisible=!0,e=this.form.view.querySelector('[taid="field-modem-mobile-network-configuration-provider-field-title"]'),t=this.form.view.querySelector("button"),(o=this.providerList.getProviderList())?[3,2]:[4,this.providerList.refreshProviderList()];case 1:n.sent(),o=this.providerList.getProviderList(),n.label=2;case 2:return o&&((i=this.getProvidersSelectElement()).disabled=!0,i.innerHTML="",o.filter((function(e){return"FORBIDDEN"!==e.state})).forEach((function(e,t){i.disabled=!1;var o=document.createElement("option");o.value=e.id+"|"+e.type,o.textContent=e.name+"|"+e.type,i.appendChild(o),"CURRENT"==e.state&&(i.selectedIndex=t)})),i.disabled?(i.innerHTML="<option>No providers found</option>",t.disabled=!0):t.disabled=!1,i.selectedIndex<0&&(i.selectedIndex=0)),e.style.display="",[2]}}))}))},t.prototype.getProvidersSelectElement=function(){return this.form.view.querySelector('[taid="field-modem-mobile-network-configuration-provider-field-title"] select')},t.prototype.hideManualProviderSelectionMenu=function(){this.providerListIsVisible=!1;var e=this.form.view.querySelector('[taid="field-modem-mobile-network-configuration-provider-field-title"]');this.form.view.querySelector("button").disabled=!1,e.style.display="none"},t}(l.ViewController);t.MobileNetworkConfig=s},function(e,t,o){var i=o(7);"string"==typeof i&&(i=[[e.i,i,""]]);var n={insert:"head",singleton:!1};o(9)(i,n);i.locals&&(e.exports=i.locals)},function(e,t,o){(e.exports=o(8)(!1)).push([e.i,".signal-quality-indicator i {\n    color: #8bb63b !important;\n}\n\n.signal-quality-indicator i:before {\n    content: ' ';\n    display: block;\n    position: absolute;\n    background: rgba(255, 255, 255, 0.79);\n    width: 25px;\n    height: 20px;\n}\n\n.signal-quality-indicator.low i:before {\n    height: 15px;\n}\n\n.signal-quality-indicator.medium i:before {\n    height: 10.5px;\n}\n\n.signal-quality-indicator.high i:before {\n    height: 0px;\n}",""])},function(e,t,o){"use strict";e.exports=function(e){var t=[];return t.toString=function(){return this.map((function(t){var o=function(e,t){var o=e[1]||"",i=e[3];if(!i)return o;if(t&&"function"==typeof btoa){var n=(a=i,l=btoa(unescape(encodeURIComponent(JSON.stringify(a)))),s="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(l),"/*# ".concat(s," */")),r=i.sources.map((function(e){return"/*# sourceURL=".concat(i.sourceRoot).concat(e," */")}));return[o].concat(r).concat([n]).join("\n")}var a,l,s;return[o].join("\n")}(t,e);return t[2]?"@media ".concat(t[2],"{").concat(o,"}"):o})).join("")},t.i=function(e,o){"string"==typeof e&&(e=[[null,e,""]]);for(var i={},n=0;n<this.length;n++){var r=this[n][0];null!=r&&(i[r]=!0)}for(var a=0;a<e.length;a++){var l=e[a];null!=l[0]&&i[l[0]]||(o&&!l[2]?l[2]=o:o&&(l[2]="(".concat(l[2],") and (").concat(o,")")),t.push(l))}},t}},function(e,t,o){"use strict";var i,n={},r=function(){return void 0===i&&(i=Boolean(window&&document&&document.all&&!window.atob)),i},a=function(){var e={};return function(t){if(void 0===e[t]){var o=document.querySelector(t);if(window.HTMLIFrameElement&&o instanceof window.HTMLIFrameElement)try{o=o.contentDocument.head}catch(e){o=null}e[t]=o}return e[t]}}();function l(e,t){for(var o=[],i={},n=0;n<e.length;n++){var r=e[n],a=t.base?r[0]+t.base:r[0],l={css:r[1],media:r[2],sourceMap:r[3]};i[a]?i[a].parts.push(l):o.push(i[a]={id:a,parts:[l]})}return o}function s(e,t){for(var o=0;o<e.length;o++){var i=e[o],r=n[i.id],a=0;if(r){for(r.refs++;a<r.parts.length;a++)r.parts[a](i.parts[a]);for(;a<i.parts.length;a++)r.parts.push(h(i.parts[a],t))}else{for(var l=[];a<i.parts.length;a++)l.push(h(i.parts[a],t));n[i.id]={id:i.id,refs:1,parts:l}}}}function d(e){var t=document.createElement("style");if(void 0===e.attributes.nonce){var i=o.nc;i&&(e.attributes.nonce=i)}if(Object.keys(e.attributes).forEach((function(o){t.setAttribute(o,e.attributes[o])})),"function"==typeof e.insert)e.insert(t);else{var n=a(e.insert||"head");if(!n)throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");n.appendChild(t)}return t}var c,u=(c=[],function(e,t){return c[e]=t,c.filter(Boolean).join("\n")});function f(e,t,o,i){var n=o?"":i.css;if(e.styleSheet)e.styleSheet.cssText=u(t,n);else{var r=document.createTextNode(n),a=e.childNodes;a[t]&&e.removeChild(a[t]),a.length?e.insertBefore(r,a[t]):e.appendChild(r)}}function m(e,t,o){var i=o.css,n=o.media,r=o.sourceMap;if(n&&e.setAttribute("media",n),r&&btoa&&(i+="\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(r))))," */")),e.styleSheet)e.styleSheet.cssText=i;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(i))}}var p=null,v=0;function h(e,t){var o,i,n;if(t.singleton){var r=v++;o=p||(p=d(t)),i=f.bind(null,o,r,!1),n=f.bind(null,o,r,!0)}else o=d(t),i=m.bind(null,o,t),n=function(){!function(e){if(null===e.parentNode)return!1;e.parentNode.removeChild(e)}(o)};return i(e),function(t){if(t){if(t.css===e.css&&t.media===e.media&&t.sourceMap===e.sourceMap)return;i(e=t)}else n()}}e.exports=function(e,t){(t=t||{}).attributes="object"==typeof t.attributes?t.attributes:{},t.singleton||"boolean"==typeof t.singleton||(t.singleton=r());var o=l(e,t);return s(o,t),function(e){for(var i=[],r=0;r<o.length;r++){var a=o[r],d=n[a.id];d&&(d.refs--,i.push(d))}e&&s(l(e,t),t);for(var c=0;c<i.length;c++){var u=i[c];if(0===u.refs){for(var f=0;f<u.parts.length;f++)u.parts[f]();delete n[u.id]}}}}},function(e){e.exports=JSON.parse('{"title":{"default":"Mobile Network Configuration","localized":"modem-mobile-network-configuration-form-title"},"sections":[{"fields":[{"title":{"default":"State","localized":"modem-mobile-network-configuration-state-field-title"},"parameter":"modem.mobilenetwork.state","control":{"type":"dropdown","items":[{"value":"INVALID","title":{"default":"Unknown","localized":"modem-mobile-network-configuration-state-unknown"}},{"value":"STOPPED","title":{"default":"Not registered","localized":"modem-mobile-network-configuration-state-not-registered"}},{"value":"HOMENET","title":{"default":"Registered","localized":"modem-mobile-network-configuration-state-registered"}},{"value":"STARTED","title":{"default":"Not registered","localized":"modem-mobile-network-configuration-state-not-registered"}},{"value":"DENIED","title":{"default":"Not registered","localized":"modem-mobile-network-configuration-state-not-registered"}},{"value":"ROAMING","title":{"default":"Registered","localized":"modem-mobile-network-configuration-state-registered"}},{"value":"NOSERVICE","title":{"default":"Not registered","localized":"modem-mobile-network-configuration-state-not-registered"}},{"value":"UNKNOWN","title":{"default":"Unknown","localized":"modem-mobile-network-configuration-state-unknown"}}]},"options":{"readonly":true}},{"title":{"default":"Signal Quality (%)","localized":"modem-mobile-network-configuration-signal-quality-field-title"},"parameter":"modem.mobilenetwork.signalquality","control":{"type":"textfield"},"options":{"readonly":true}},{"title":{"default":"Operator","localized":"modem-mobile-network-configuration-operator-field-title"},"parameter":"modem.mobilenetwork.operator.name","control":{"type":"dropdown","items":[{"value":"${modem.mobilenetwork.operator.name}","title":{"default":"${modem.mobilenetwork.operator.name}|${modem.mobilenetwork.operator.type}","localized":"modem-mobile-network-configuration-operator-value"}}]},"options":{"readonly":true}}]},{"fields":[{"title":{"default":"Selection Mode","localized":"modem-mobile-network-configuration-selection-mode-field-title"},"parameter":"modem.mobilenetwork.selectionmode","control":{"type":"dropdown","items":[{"value":"AUTOMATIC","title":{"default":"Automatic","localized":"modem-mobile-network-configuration-selection-mode-automatic"}},{"value":"ONLY_UMTS","title":{"default":"Automatic - UMTS only","localized":"modem-mobile-network-configuration-selection-mode-only-umts"}},{"value":"ONLY_GSM","title":{"default":"Automatic - GSM only","localized":"modem-mobile-network-configuration-selection-mode-only-gsm"}},{"value":"MANUAL","title":{"default":"Manual","localized":"modem-mobile-network-configuration-selection-mode-manual"}}]}},{"title":{"default":"Provider","localized":"modem-mobile-network-configuration-provider-field-title"},"parameter":"modem.mobilenetwork.provider","control":{"type":"dropdown","items":[]}}]}]}')},function(e){e.exports=JSON.parse('{"title":{"default":"Upload and activate new Modem Software","localized":"modem-firmware-update-form-title"},"sections":[{"fields":[{"title":{"default":"Currently used","localized":"modem-firmware-version-field-title"},"parameter":"modem.firmware.version","control":{"type":"textfield"},"options":{"readonly":true}}]}]}')},function(e){e.exports=JSON.parse('{"title":{"default":"SIM Authentication","localized":"modem-sim-authentication-form-title"},"sections":[{"fields":[{"parameter":"modem.simstate","control":{"type":"dropdown","items":[{"value":"","title":{"default":"Error while reading SIM Data.","localized":"modem-sim-state-error"}},{"value":"NOT_INSERTED","title":{"default":"SIM card not inserted","localized":"modem-sim-not-inserted"}},{"value":"SIM_PIN","title":{"default":"PIN Requested","localized":"modem-sim-pin-requested"}},{"value":"SIM_PUK","title":{"default":"PIN unsuccessfull, PUK requested","localized":"modem-sim-pin-requested"}},{"value":"READY","title":{"default":"Ready","localized":"modem-ready"}},{"value":"NOT_READY","title":{"default":"Not Ready","localized":"modem-sim-pin-not-ready"}},{"value":"ERROR","title":{"default":"Error while reading SIM Data.","localized":"modem-sim-state-error"}},{"value":"UNKNOWN","title":{"default":"SIM card status unknown.","localized":"modem-sim-state-unknown"}}]},"options":{"readonly":true}}]},{"hidden":"modem.simstate is not SIM_PIN","fields":[{"title":{"default":"Enter PIN","localized":"modem-sim-pin-field-title"},"argument":"pin","control":{"type":"textfield","options":{"masked":true}}},{"title":{"default":"Attempts left","localized":"modem-sim-pin-left-attempts-field-title"},"parameter":"modem.leftattempts","control":{"type":"textfield"},"options":{"readonly":true}}],"action":{"title":{"default":"Unlock","localized":"modem-sim-unlock-action-title"},"method":"modem.unlocksimbypin"}},{"hidden":"modem.simstate is not SIM_PUK","fields":[{"title":{"default":"Enter new PIN","localized":"modem-sim-pin-field-title"},"argument":"newPin","control":{"type":"textfield","options":{"masked":true}}},{"title":{"default":"Enter PUK","localized":"modem-sim-puk-field-title"},"argument":"puk","control":{"type":"textfield","options":{"masked":true}}},{"title":{"default":"Attempts left","localized":"modem-sim-puk-left-attempts-field-title"},"parameter":"modem.leftattempts","control":{"type":"textfield"},"options":{"readonly":true}}],"action":{"title":{"default":"Unlock","localized":"modem-sim-unlock-action-title"},"method":"modem.unlocksimbypuk"}}]}')},function(e){e.exports=JSON.parse('{"title":{"default":"Network Package Service","localized":"modem-network-package-service-form-title"},"sections":[{"fields":[{"title":{"default":"Enabled","localized":"modem-network-package-service-enabled-field-title"},"parameter":"modem.networkpackageservice.enabled","control":{"type":"checkbox"}},{"title":{"default":"State","localized":"modem-network-package-service-state-field-title"},"parameter":"modem.networkpackageservice.state","control":{"type":"dropdown","items":[{"value":"INVALID","title":{"default":"Unknown","localized":"modem-network-package-service-state-unknown"}},{"value":"STOPPED","title":{"default":"Not registered","localized":"modem-network-package-service-state-not-registered"}},{"value":"HOMENET","title":{"default":"Registered","localized":"modem-network-package-service-state-registered"}},{"value":"STARTED","title":{"default":"Not registered","localized":"modem-network-package-service-state-not-registered"}},{"value":"DENIED","title":{"default":"Not registered","localized":"modem-network-package-service-state-not-registered"}},{"value":"ROAMING","title":{"default":"Registered","localized":"modem-network-package-service-state-registered"}},{"value":"NOSERVICE","title":{"default":"Not registered","localized":"modem-network-package-service-state-not-registered"}},{"value":"UNKNOWN","title":{"default":"Unknown","localized":"modem-network-package-service-state-unknown"}}]},"options":{"readonly":true}},{"title":{"default":"APN","localized":"modem-network-package-service-apn-field-title"},"parameter":"modem.networkpackageservice.accesspointname","control":{"type":"textfield"}},{"title":{"default":"User","localized":"modem-network-package-service-user-field-title"},"parameter":"modem.networkpackageservice.username","control":{"type":"textfield"}},{"title":{"default":"Password","localized":"modem-network-package-service-password-field-title"},"parameter":"modem.networkpackageservice.password","control":{"type":"textfield"}},{"title":{"default":"Authentication Type","localized":"modem-network-package-service-authentication-type-field-title"},"parameter":"modem.networkpackageservice.authenticationtype","control":{"type":"dropdown","items":[{"value":"NONE","title":{"default":"None","localized":"modem-network-package-service-authentication-type-none"}},{"value":"PAP","title":{"default":"PAP","localized":"modem-network-package-service-authentication-type-pap"}},{"value":"CHAP","title":{"default":"CHAP","localized":"modem-network-package-service-authentication-type-chap"}},{"value":"PAP_OR_CHAP","title":{"default":"PAP or CHAP","localized":"modem-network-package-service-authentication-type-pap-or-chap"}}]}}]}]}')}])}));
//# sourceMappingURL=modem.js.map